include "locomotive.gs"
//=======================================================================================
// Script original de Globule modifi par Fred24  04-01-09
//=======================================================================================
//
//	CLASS
//
//=======================================================================================
class FEUX isclass Locomotive
{
    define int CAR_DERAILED = -1;
    define int CAR_CENTER = 0;
    define int CAR_FRONT = 1;
    define int CAR_BACK = 2;
    define int CAR_SINGLE = 3;

	Asset feuBlanc, feuRouge;
	Train myTrain;
	int carPosition = 1;			// +1 = Tte ; 0 = Milieu ; = -1 -> Queue
	int isHLP = 1;				// 1 = HLP ; 0 = Convoi

	void CheckCarPosition(void);
	void SetLights(void);	                                     
	void VehicleHandler(Message msg);
	void TrainHandler(Message msg);
	thread void ControlMonitor();



//=======================================================================================
//	Init
//=======================================================================================
  	public void Init(void)
  	{
	    inherited();
		feuBlanc = me.GetAsset().FindAsset("feublanc");
		feuRouge = me.GetAsset().FindAsset("feurouge");
		myTrain = me.GetMyTrain();
		if (myTrain!= null)
			{
			me.Sniff(myTrain, "Train", null, true);
			}
		AddHandler(me, "Vehicle", null, "VehicleHandler");    
		AddHandler(me, "Train", null, "TrainHandler");    
		AddHandler(me, "CabControl", null, "CabControlHandler");    
    		SetFXCoronaTexture("feublanc1", null);
	  	SetFXCoronaTexture("feublanc2", null);
       	SetFXCoronaTexture("feublanc3", null);
       	SetFXCoronaTexture("feublanc4", null);
        	SetFXCoronaTexture("feurouge1", null);
        	SetFXCoronaTexture("feurouge2", null);
        	SetFXCoronaTexture("feurouge3", null);
        	SetFXCoronaTexture("feurouge4", null);
     	//ControlMonitor();
  	}
//=======================================================================================



//=======================================================================================
//	CheckCarPosition
//=======================================================================================
  	void CheckCarPosition(void)
  	{
		Vehicle[] cars;

		cars = me.GetMyTrain().GetVehicles();
		if (cars.size() == 1)
			{
			carPosition = CAR_SINGLE;				//isHLP = 1;
			}
		else
			{
			
			if (me == cars[0])					//isHLP = 0;
				{
				carPosition = CAR_FRONT;			//carPosition = +1;
				}       	
			else
				{       	
				if (me == cars[cars.size() - 1])
	   				{
					carPosition = CAR_BACK;			//carPosition = -1;
   					}
	   			else
	   				{
					carPosition = CAR_CENTER;		//carPosition = 0;
   					}
				}
			}			
  	}
//=======================================================================================



//=======================================================================================
//	SetLights
//=======================================================================================
  	void SetLights(void)
  	{
		float direction_DCC,direction_CAB;
		bool	direction_AUTO;
		int	direction;
		
		
		direction_AUTO = GetDirectionRelativeToTrain();		// fonctionne en conduite automatique dans les 2 modes
												// TRUE  AI en avant
												// FALSE AI en arriere (inverse tous les feux en mode couple)
		direction_DCC  = myTrain.GetDCCThrottle();		// fonctionne en conduite manuelle en mode DCC
												// 1  Avant
												// -1 Arriere
		direction_CAB  = GetEngineSetting("reverser"); 		// fonctionne en conduite manuelle en mode cabine
												// 1  Avant
												// -1 Arriere

		
		if (direction_DCC > 0 or direction_CAB > 0)		// determination de sens de marche en DCC ou en cabine
			{									//
			direction = 2;							//
			}									//
		if (direction_DCC == 0 or direction_CAB == 0)			//
			{									//
			direction = 1;							//
			}									//
		if (direction_DCC < 0 or direction_CAB < 0)			//
			{									//
			direction = 0;							//
			}									//



      	 if (carPosition == CAR_CENTER)				// Machine en position vehicule
    			{
    			SetFXCoronaTexture("feublanc1", null);
	  	    	SetFXCoronaTexture("feublanc2", null);
       	 	SetFXCoronaTexture("feublanc3", null);
       	 	SetFXCoronaTexture("feublanc4", null);
        		SetFXCoronaTexture("feurouge1", null);
        		SetFXCoronaTexture("feurouge2", null);
        		SetFXCoronaTexture("feurouge3", null);
        		SetFXCoronaTexture("feurouge4", null);
			}    			

	if (direction_AUTO)							// AI dans le sens de la marche 
		{		
		if (carPosition == CAR_SINGLE)				// Machine en HLP (machine seule)
			{
			if (direction == 2)					// Marche avant
				{
         			SetFXCoronaTexture("feublanc1", feuBlanc);
	        		SetFXCoronaTexture("feublanc2", feuBlanc);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", feuRouge);
        			SetFXCoronaTexture("feurouge4", feuRouge);
				}
			else if (direction == 0)				// Marche arriere
				{
        			SetFXCoronaTexture("feublanc1", null);
	        		SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", feuBlanc);
        			SetFXCoronaTexture("feublanc4", feuBlanc);
        			SetFXCoronaTexture("feurouge1", feuRouge);
        			SetFXCoronaTexture("feurouge2", feuRouge);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
				}
//			else								// Neutre
//				{
//        			SetFXCoronaTexture("feublanc1", null);
//	        		SetFXCoronaTexture("feublanc2", null);
//        			SetFXCoronaTexture("feublanc3", null);
//        			SetFXCoronaTexture("feublanc4", null);
//        			SetFXCoronaTexture("feurouge1", feuRouge);
//        			SetFXCoronaTexture("feurouge2", feuRouge);
//        			SetFXCoronaTexture("feurouge4", feuRouge);
//				}		
			}
		else if (carPosition == CAR_FRONT)					// Machine en tte de train
 			{
			if (direction == 2)						// Marche avant
				{
        			SetFXCoronaTexture("feublanc1", feuBlanc);
	       		SetFXCoronaTexture("feublanc2", feuBlanc);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
				}
			else									// Marche arrire ou neutre
				{
				SetFXCoronaTexture("feublanc1", null);
	     			SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", feuRouge);
        			SetFXCoronaTexture("feurouge2", feuRouge);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
				}
			}
 		else if (carPosition == CAR_BACK)					// Machine en queue de train
			{
			if (direction == 0)						// Marche arrire
				{
				SetFXCoronaTexture("feublanc1", null);
	       		SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", feuBlanc);
        			SetFXCoronaTexture("feublanc4", feuBlanc);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
   				}
   			else									// Marche avant ou neutre
   				{
        			SetFXCoronaTexture("feublanc1", null);
	       		SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", feuRouge);
        			SetFXCoronaTexture("feurouge4", feuRouge);
				}
			}
		}
	if (!direction_AUTO)								// AI dans le sens inverse de la marche
		{		
 		if (carPosition == CAR_SINGLE)				// Machine en HLP (machine seule)
			{
			if (direction == 2)					// Marche avant
				{
        			SetFXCoronaTexture("feublanc1", null);
	        		SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", feuBlanc);
        			SetFXCoronaTexture("feublanc4", feuBlanc);
        			SetFXCoronaTexture("feurouge1", feuRouge);
        			SetFXCoronaTexture("feurouge2", feuRouge);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
				}
			else if (direction == 0)				// Marche arriere
				{
         			SetFXCoronaTexture("feublanc1", feuBlanc);
	        		SetFXCoronaTexture("feublanc2", feuBlanc);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", feuRouge);
        			SetFXCoronaTexture("feurouge4", feuRouge);
				}
//			else								// Neutre
//				{
//        			SetFXCoronaTexture("feublanc1", null);
//	        		SetFXCoronaTexture("feublanc2", null);
//        			SetFXCoronaTexture("feublanc3", null);
//        			SetFXCoronaTexture("feublanc4", null);
//        			SetFXCoronaTexture("feurouge1", feuRouge);
//        			SetFXCoronaTexture("feurouge2", feuRouge);
//        			SetFXCoronaTexture("feurouge3", feuRouge);
//        			SetFXCoronaTexture("feurouge4", feuRouge);
//				}		
			}
		else if (carPosition == CAR_BACK)						// Machine en tte de train ( inverse quand l AI est a l envers )
 		 	{
			if (direction == 2)						// Marche avant
				{
				SetFXCoronaTexture("feublanc1", null);
	     			SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", feuRouge);
        			SetFXCoronaTexture("feurouge2", feuRouge);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
				}
			else									// Marche arrire ou neutre
				{
        			SetFXCoronaTexture("feublanc1", feuBlanc);
	       		SetFXCoronaTexture("feublanc2", feuBlanc);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
				}
			}
 		else if (carPosition == CAR_FRONT)					// Machine en queue de train ( inverse quand l AI est a l envers )
			{
			if (direction == 0)						// Marche arrire
				{
        			SetFXCoronaTexture("feublanc1", null);
	       		SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", null);
        			SetFXCoronaTexture("feublanc4", null);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", feuRouge);
        			SetFXCoronaTexture("feurouge4", feuRouge);
   				}
   			else									// Marche avant ou neutre
   				{
				SetFXCoronaTexture("feublanc1", null);
	       		SetFXCoronaTexture("feublanc2", null);
        			SetFXCoronaTexture("feublanc3", feuBlanc);
        			SetFXCoronaTexture("feublanc4", feuBlanc);
        			SetFXCoronaTexture("feurouge1", null);
        			SetFXCoronaTexture("feurouge2", null);
        			SetFXCoronaTexture("feurouge3", null);
        			SetFXCoronaTexture("feurouge4", null);
				}
			} 
 		}
  	}



//=======================================================================================



//=======================================================================================
//		VehicleMonitor
//=======================================================================================
	void VehicleHandler(Message msg)
  	{
      	if (myTrain != null)
			{
      		me.Sniff(myTrain, "Train", null, false);
      		}
      	myTrain = me.GetMyTrain();
      	if (myTrain != null)
			{
         		me.Sniff(myTrain, "Train", null, true);
      		}
      	CheckCarPosition();
      	SetLights();
	}
//=======================================================================================



//=======================================================================================
//		TrainHandler
//=======================================================================================
	void TrainHandler(Message msg)
  	{
      	CheckCarPosition();
      	SetLights();
	}
//=======================================================================================



//=======================================================================================
//		CabControlHandler
//=======================================================================================
	void CabControlHandler(Message msg)
  	{
      	CheckCarPosition();
      	SetLights();
	}
//=======================================================================================



//=======================================================================================
//		ControlMonitor
//=======================================================================================
	thread void ControlMonitor(void)
  	{
      	while (true)
			{
	      	CheckCarPosition();
   	   		SetLights();
      		Sleep(5);
  			}
	}
//=======================================================================================
};
